---
import ScrollNotice from "~/components/ScrollNotice/ScrollNotice.astro";
import { getLangFromUrl } from "../i18n/utils";
import { SEO } from "astro-seo";
const lang = getLangFromUrl(Astro.url);
---

<script>
  import { gsap } from "gsap";
  import { ScrollTrigger } from "gsap/ScrollTrigger";
  gsap.registerPlugin(ScrollTrigger);
  // Cascade image (imagine tetris blocks)
  const tl = gsap.timeline({
    defaults: { ease: "power1.inOut", duration: 0.5 },
    scrollTrigger: {
      trigger: "#intro",
      start: "center center",
    },
  });
  function splitText(cssSelector: string, _options: { type: "chars" }) {
    const initialElement = document.querySelector(cssSelector);
    if (initialElement != null) {
      const text = initialElement.innerHTML;

      initialElement.innerHTML = "";
      const elements = Array.from(text).map((letter: string) => {
        const element = document.createElement("div");
        element.className = "split-text " + cssSelector.replace(/[\.#]/gi, "");
        element.innerHTML = letter;
        element.style.display = "inline-block";
        Array.from(initialElement.attributes).forEach((attr) => {
          if (attr.name == "id") {
            return;
          }
          element.setAttribute(attr.name, attr.value);
        });
        initialElement.appendChild(element);
        //parent?.insertBefore(element, prevNode);
        return element;
      });
      return { chars: elements };
    }
    return { chars: [""] };
  }
  const gallery = splitText(".highlight", { type: "chars" });
  gsap.from(gallery.chars, {
    duration: 0.5,
    opacity: 0,
    scale: 0,
    y: 80,
    rotationX: 180,
    transformOrigin: "0% 50% -50",
    ease: "back",
    stagger: 0.05,
  });
  const showcase = splitText("#showcase", { type: "chars" });
  tl.from(showcase.chars, {
    duration: 0.5,
    opacity: 0,
    scale: 0,
    y: 80,
    rotationX: 180,
    transformOrigin: "0% 50% -50",
    ease: "back",
    stagger: 0.05,
  });
  tl.addLabel("your").to(".text-your", { y: 200, opacity: 1 }, "-=80%");
  tl.addLabel("art").to(".text-art", { y: 90, opacity: 1 }, "-=50%");
  //Use a grid instead
  const grid = [2, 6] as [number, number];
  tl.to(".images__image", {
    y: 100,
    x: 200,
    opacity: 1,
    stagger: {
      amount: 0.5,
      grid: grid,
      axis: "x",
      from: 0,
      ease: "power2.inOut",
    },
  });
</script>

<style lang="sass">
  *
    vertical-align: baseline
    font-weight: inherit
    font-size: 16px
    border: 0 none
    box-sizing: border-box
    outline: 0
    padding: 0
    margin: 0
    font-family: "Quicksand", sans-serif
    font-size: 16px
  .top-index
    z-index: 99
  :root
    --dark: #063027
    --light: #3bdcb9
    --white: #fec3d0
    --main: #f5335d
    --accent: #cc0a34
    color: var(--main)
    background: var(--white)
    h1,h2,h3
      font-family: "Cherry Bomb One", system-ui
      font-weight: 400
      font-style: normal
    h1, #showcase > div
      font-family: "Cherry Bomb One", system-ui
      color: var(--main)
      font-size: 100px
      z-index: 99
      position: relative
  .highlight
    display: inline-block
    text-transform: uppercase
    transform: rotate(5deg)
    font-family: "Cherry Bomb One", system-ui
    font-weight: 500
    color: var(--accent)
    font-size: 2rem
  #root
    position: relative
    margin: 0px 2rem
  section#intro
    height: 100vh
    .teaser
      position: absolute
      top: 20%
      left: 50%
      transform: translateX(-50%)
      font-size: 2rem
    header
      width: max-content
      position: relative
      top: 35%
      height: 500px
      .images
        &__container
          position: absolute
          top: 0
          left: 0
          width: calc(220px * 3)
        &__image
          border-radius: 1rem
          opacity: 0
          display: inline-block
      .text
        &-your
          font-family: "Cherry Bomb One", system-ui
          font-size: 6rem
          position: absolute
          top: -200px
          right: -50%
          opacity: 0
          display: inline-block
          color: var(--main)
        &-art
          text-shadow: 3px 3px 0 var(--light), -3px -3px 0 var(--light)
          font-family: "Cherry Bomb One", system-ui
          font-size: 6rem
          opacity: 0
          position: absolute
          top: 0
          right: -50%
          display: inline-block
          color: var(--main)
</style>

<html lang={lang}>
  <head>
    <meta charset="utf-8" />
    <link rel="icon" type="image/svg+xml" href="/favicon.png" />
    <meta name="viewport" content="width=device-width" />
    <meta name="generator" content={Astro.generator} />
    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link rel="sitemap" href="/sitemap-index.xml" />
    <link
      href="https://fonts.googleapis.com/css2?family=Cherry+Bomb+One&family=Quicksand:wght@300..500&display=swap"
      rel="stylesheet"
    />
    <link
      rel="alternate"
      type="application/rss+xml"
      title="OwNi.dev - Web Developer"
      href={new URL("rss/feed.xml", Astro.site)}
    />
    <script
      is:inline
      defer
      src="https://umami.owni.dev/script.js"
      data-website-id="db3b4c79-eaea-4fdb-bb42-59d78b8acb70"></script>
    <SEO
      title="Websites for artists"
      description="Showcase your art with handcrafted and animated websites for artists, by an artist. Optimized for speed and images, while not breaking the bank"
      ,
      openGraph={{
        basic: {
          title: `OwNi.dev - ${lang == "en" ? "Web Developer" : "Développeur Web"}`,
          type: "website",
          image:
            "https://ownidev.syd1.digitaloceanspaces.com/uploads/business_logo.png",
        },
        optional: {
          description:
            "Showcase your art with handcrafted and animated websites for artists, by an artist.",
        },
      }}
      twitter={{
        creator: "@casyus",
      }}
      extend={{
        // extending the default link tags
        link: [{ rel: "icon", href: "/favicon.png" }],
        // extending the default meta tags
        meta: [
          {
            name: "twitter:image",
            content:
              "https://ownidev.syd1.digitaloceanspaces.com/uploads/business_logo.png",
          },
          { name: "twitter:title", content: "OwNi.Dev" },
          {
            name: "twitter:description",
            content:
              "Showcase your art with handcrafted and animated websites for artists, by an artist.",
          },
        ],
      }}
    />
  </head>
  <body>
    <main id="root">
      <ScrollNotice />
      <section id="intro">
        <div class="teaser">
          <p>This is your</p>
          <div class="highlight">gallery</div>
          <p>Here are a few things it can do:</p>
        </div>
        <header>
          <h1 class="top-index" id="showcase">SHOWCASE</h1>
          <div class="text-your top-index">your</div><div>
            <p class="text-art top-index">art</p>
          </div>
          <div class="images__container">
            <img src="https://placehold.co/200" class="images__image" />
            <img src="https://placehold.co/200" class="images__image" />
            <img src="https://placehold.co/200" class="images__image" />
            <img src="https://placehold.co/200" class="images__image" />
            <img src="https://placehold.co/200" class="images__image" />
            <img src="https://placehold.co/200" class="images__image" />
          </div>
        </header>
      </section>
      <section id="handcrafted">
        with a <div class="highlight">handcrafted</div> and <div
          class="highlight"
        >
          animated
        </div> website for artists, <a href="/gallery">by an artist</a>
      </section>
    </main>
  </body>
</html>
